//
//  Duck.m
//  DuckSimulator
//
//  Created by Ken Anderson on 9/5/11.
//  Copyright 2011 University of Colorado, Boulder. All rights reserved.
//

#import "Duck.h"
#import "FlyWithWings.h"
#import "Quack.h"

@implementation Duck

@synthesize flyBehavior=_flyBehavior;
@synthesize quackBehavior=_quackBehavior;

- (id)init {
    self = [super init];
    if (self) {
        self.flyBehavior = [[[FlyWithWings alloc] init] autorelease];
        self.quackBehavior = [[[Quack alloc] init] autorelease];
    }    
    return self;
}

- (void)dealloc {
    [_flyBehavior release];
    [_quackBehavior release];
}

- (void) display {
    QuietLog(@"%@: I'M A BAD SUBCLASS!!!! (Unless I'm a Duck and then everything is fine.)", [self class]);
}

- (void)fly {
    QuietLog(@"%@: %@", [self class], [self.flyBehavior fly]);
}

- (void) quack {
    QuietLog(@"%@: %@", [self class], [self.quackBehavior quack]);    
}

- (void) swim {
    QuietLog(@"%@: All ducks can swim!", [self class]);
}


@end
