//
//  main.m
//  DuckSimulator
//
//  Created by Ken Anderson on 9/5/11.
//  Copyright 2011 University of Colorado, Boulder. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Duck.h"
#import "DecoyDuck.h"
#import "MallardDuck.h"
#import "ModelDuck.h"
#import "RedHeadDuck.h"
#import "RubberDuck.h"

#import "FlyRocketPowered.h"
#import "Squeak.h"

void processDucks(NSArray* ducks);

void processDucks(NSArray* ducks) {
    for (Duck* duck in ducks) {
        QuietLog(@"-----------------------------------------------------------");
        [duck display];
        [duck quack];
        [duck fly];
        [duck swim];
    }
}

int main (int argc, const char * argv[]) {

    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];

    NSMutableArray* ducks = [[NSMutableArray alloc] initWithCapacity:5];
    
    [ducks addObject:[[[Duck alloc] init] autorelease]];
    [ducks addObject:[[[DecoyDuck alloc] init] autorelease]];
    [ducks addObject:[[[MallardDuck alloc] init] autorelease]];
    [ducks addObject:[[[RedHeadDuck alloc] init] autorelease]];
    [ducks addObject:[[[RubberDuck alloc] init] autorelease]];
 
    ModelDuck* model = [[[ModelDuck alloc] init] autorelease];
  
    [ducks addObject:model];

    
    processDucks(ducks);
    
    QuietLog(@"-----------------------------------------------------------");
    QuietLog(@"@@@ CHANGING BEHAVIORS OF ModelDuck");
    
    model.flyBehavior = [[[FlyRocketPowered alloc] init] autorelease];
    model.quackBehavior = [[[Squeak alloc] init] autorelease];
    
    processDucks(ducks);
    
    [ducks release];

    [pool drain];
    return 0;
}

